# -*- python -*-
#
#  deliver.py  $Revision: 2.6 $
#
#  Copyright (C) 1999  Christian Moench
#
#  $Id: deliver.py,v 2.6 1999/12/19 16:14:43 razi Exp $ $Date: 1999/12/19 16:14:43 $
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#  Christian Moench
#  Dept. of Computer Science
#  Johann Wolfgang Goethe-University
#  60325 Frankfurt, Germany
#  Tel.  +49 69 79828358
#  Fax.  +49 69 79823340
#
#  $Log: deliver.py,v $
#  Revision 2.6  1999/12/19 16:14:43  razi
#  Including IndigoConfig.java
#
#  Revision 2.2  1999/12/15 16:34:15  cristian
#  added new clients
#
#  Revision 2.0  1999/12/15 15:38:49  cristian
#  added new clients
#
#  Revision 1.3  1999/12/15 10:19:22  cristian
#  new clients for `documents' and `quit'
#
#  Revision 1.2  1999/12/13 18:26:39  cristian
#  deliver does no longer take a default method
#  invoke client added
#
#  Revision 1.1  1999/08/09 09:32:42  cristian
#  initial
#
#  Revision 1.1.1.1  1999/07/22 15:34:08  cristian
#  Initial release
#
#


def main():
	import string, sys, httplib
	
	if len(sys.argv) < 4:
		sys.stderr.write("usage: deliver server"
				 + " portnumber metadoc [defaultmethod"
				 + " {arguments}]\n")
		sys.exit(1)

	# Convert port number to integer
	try:
		port = int(sys.argv[2])
	except:
		sys.stderr.write("illegal port number\n")
		sys.exit(2)

	# Assemble path and send post request
	#path = "/diglib/deliver?" + sys.argv[4]
	#for i in range(5, len(sys.argv)):
	#	path = path + "&" + sys.argv[i]
	path = "/diglib/deliver"
	httpStub = httplib.HTTP(sys.argv[1], port)
	httpStub.putrequest("POST", path)
	httpStub.endheaders()

	# Send meta document
	metadoc = open(sys.argv[3])
	data = metadoc.readline()
	while data:
		httpStub.send(data)
		data = metadoc.readline()
	metadoc.close()

	# Check reply code
	reply = httpStub.getreply()
        if reply[0] <> 200:
            sys.stderr.write('%d %s\n\n' % reply[0:2])
            # Show errors
            server = httpStub.getfile()
            data = server.read()
            while data:
		sys.stderr.write(data + '\n')
		data = server.read()
            sys.exit(3)

	# Show method results
	server = httpStub.getfile()
	data = server.read()
	while data:
		print data
		data = server.read()
	return


main()
