# -*- python -*-
#
#  invoke.py
#
#  Copyright (C) 1999  Christian Moench
#
#  $Id: invoke.py,v 2.7 1999/12/21 14:50:20 cristian Exp $
#  $Date: 1999/12/21 14:50:20 $
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#  Christian Moench
#  Dept. of Computer Science
#  Johann Wolfgang Goethe-University
#  60325 Frankfurt, Germany
#  Tel.  +49 69 79828358
#  Fax.  +49 69 79823340
#
#  $Log: invoke.py,v $
#  Revision 2.7  1999/12/21 14:50:20  cristian
#  invoke now prints results as they arrive
#  changed exec flags on quit
#
#  Revision 2.6  1999/12/19 16:14:44  razi
#  Including IndigoConfig.java
#
#  Revision 2.2  1999/12/15 16:34:17  cristian
#  added new clients
#
#  Revision 2.0  1999/12/15 15:38:51  cristian
#  added new clients
#
#  Revision 1.2  1999/12/15 10:19:24  cristian
#  new clients for `documents' and `quit'
#
#  Revision 1.1  1999/12/13 18:26:40  cristian
#  deliver does no longer take a default method
#  invoke client added
#
#


def main():
	import string, sys, socket
	
	if len(sys.argv) < 5:
		sys.stderr.write("usage: invoke server"
				 + " portnumber docid method"
				 + " {arguments}\n")
		sys.exit(1)

	# Convert port number to integer
	try:
		port = int(sys.argv[2])
	except:
		sys.stderr.write("illegal port number\n")
		sys.exit(2)

	serverSocket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	serverSocket.connect(sys.argv[1], port)

	# Assemble path and send request
	url = "GET /diglib/invoke/%s?%s" % (sys.argv[3], sys.argv[4])
	for i in range(5, len(sys.argv)):
		url = url + "&" + sys.argv[i]
	url = url + " HTTP/1.0"

	# Send request
	serverSocket.send(url + '\n\n\n')

	# Read result
	serverFile = serverSocket.makefile('r')
	data = serverFile.readline()
	while data:
		print data[:-1]
		data = serverFile.readline()
	return


main()
