/**
 * Present.java
 *
 *
 * @author Razi Lotfi-Tabrizi
 * @version
 */

import java.util.*;
import java.io.*;
import java.lang.*;
import java.net.*;



public class Present {
    
    public static void main(String args[]) {
	Io.init();

	if (args.length != 3) 
	    {
		System.err.println("usage: Present <id> <host> <port>");
		return;
	    }
	
	int portnumber;
	try 
	    {
		portnumber = new Integer(args[2]).intValue();
	    }
	catch (Exception e) 
	    {
		System.err.println("Bad port number: " + args[2]);
		return;
	    }
	
	// Einfache Infos ueber die Argumente:
	Io.println("Hier wird die Present.class gestartet...");
	Io.println("{");
	Io.println("args.length: " + args.length);
	Io.println("Die Argumente der Main-Methode sind:");
	for (int i = 0; i < args.length ; i++) 
	    {
		Io.println("Argument " + i + ":  " + args[i]);
	    }
	Io.println("}");
	Io.println("");
	
	// Serving socket erzeugen
	// args[0] ist die DocumentId.
	ServerSocket server;
	String[] lpresentArgs = new String[3];
	try {
	    server = new ServerSocket(0);
	    lpresentArgs[0] = InetAddress.getLocalHost().getHostName();
	    lpresentArgs[1] = Integer.toString(server.getLocalPort());
	    lpresentArgs[2] = args[0];
	}
	catch (Exception e) {
	    System.err.println(e.toString());
	    return;
	}
	Io.println("Starte Present:  Dieses Dokument wird nach " + args[1] + ":" + 
		   args[2] + "\ngeschick und dort wird anschliessend Flic_Player gestartet !\n");   
	
	System.err.println("HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH");
	// Als newId erhaelt man die DocId auf der client-Seite.
	String newId = Base.d_transport(args[1], portnumber, args[0]);
	
	System.err.println("HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH");
	// Starte anschliessend auf dem Client die Methode TextView
	Base.invokeAsync(args[1], portnumber, newId, "Flic_Player", lpresentArgs);
	
	Socket socket = null;
	InputStream inData = null;
	OutputStream outData = null;

	try {		
	    int len;
	    byte b[] = new byte[100];
	    String line="";
	    
	    socket = server.accept();
	    inData = socket.getInputStream();
	    outData = socket.getOutputStream();

	    File contentFile = Self.getContentFile();
	    FileInputStream  fis = new FileInputStream(contentFile);

	    // Achtung hier muss man nicht gleich schreiben!
	    //  	    while(! ((len = fis.read(b)) == -1)) {
	    //  		System.err.write(b, 0, len);
	    //  		outData.write(b,0,len);
	    //  		outData.flush();
	    //  	    }
	    
	    // Warten bis der Client auf Ende drueckt!
	    Io.println("Hier wird die Present.class beendet...");
	    try {
		Thread.currentThread().sleep(10000);
	    }
	    catch (InterruptedException e) {}
	    socket.close();
	    server.close();
	}
	catch (Exception e) {
	    System.err.println(e.toString());
	}	
	Io.exit();
    }
}

