/*
 *  Present.java   implements Present method of jimage
 *
 *  $Revision: 1.1 $
 *  $Date: 2000/03/22 20:56:44 $
 *
 *  Copyright (C) 1999-2000  Christian Moench
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  $Log: Present.java,v $
 *  Revision 1.1  2000/03/22 20:56:44  cristian
 *  Local presentation of images with java methods
 *
 *
 */
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class Present {

    // Present takes three arguments, a document id, a hostname and a
    // port number.
    public static void main(String args[]) {

	System.err.println("Present starts");

	if (args.length != 3) {
	    System.err.println("usage: Present <id> <host> <port>");
	    return;
	}

	int number;
	try {
	    number = new Integer(args[2]).intValue();
	}
	catch (Exception e) {
	    System.err.println("Bad port number: " + args[2]);
	    return;
	}

	// Perform server provided transport on myself and invoke e
	String newId = Base.s_transport(args[1], number, args[0]);
	Base.invokeAsync(args[1], number, newId, "localPresent", null);

	System.err.println("Present done.");
	return;
    }
}
