/*
 *  localPresent.java  implements local present method of jimage
 *
 *  $Revision: 1.1 $
 *  $Date: 2000/03/22 20:56:44 $
 *
 *  Author:  Christian Moench
 *  Modified by: Razi Lotfi

 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class localPresent extends JFrame {

    Image img;
    MediaTracker mt;
    public static localPresent tester;


    public localPresent(String id)  throws Exception {
	super("localPresent " + id);

	setSize(625, 325);
	setVisible(true);

  	img = getToolkit().getImage(Self.getContentFileName(id));
  	repaint();

        addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    synchronized(tester) {
			tester.notifyAll();
		    }
		}
	    });
    }

    public void paint(Graphics g) {
	if (img != null) {
	    g.drawImage(img, 0, 0, this);
	}
    }

    public static void main(String args[]) throws Exception {

	if (args.length != 1) {
	    System.err.println("usage: localPresent <id>");
	    return;
	}

	tester = new localPresent(args[0]);
	tester.show();

	synchronized(tester) {
	    tester.wait();
	}
	return;
    }
}








