/*
 *  LPresent.java  $Revision: 1.1.1.1 $
 *
 *  $Id: LPresent.java,v 1.1.1.1 1999/12/20 13:11:59 razi Exp $
 *  $Date: 1999/12/20 13:11:59 $
 *
 *  Copyright (C) 1999  Christian Moench
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Christian Moench
 *  Dept. of Computer Science
 *  Johann Wolfgang Goethe-University
 *  60325 Frankfurt, Germany
 *  Tel.  +49 69 79828358
 *  Fax.  +49 69 79823340
 *
 *  $Log: LPresent.java,v $
 *  Revision 1.1.1.1  1999/12/20 13:11:59  razi
 *  Lokale Indigo Server auf papageno
 *
 *  Revision 2.2  1999/12/15 16:44:12  cristian
 *  new revision
 *
 *  Revision 1.3  1999/12/15 10:19:54  cristian
 *  new demo document with `d_transport' and `invokeAsync'
 *
 *  Revision 1.2  1999/12/13 21:12:38  cristian
 *  started exit handling
 *
 *  Revision 1.1  1999/12/13 18:28:03  cristian
 *  first nettext version
 *
 *
 */
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;
import javax.swing.*;


public class LPresent extends JFrame{

    JTextArea      textArea;
    JScrollPane    scrollPane;
    JButton        moreButton;
    BufferedReader input;
    PrintWriter    output;

    public InetAddress inetAddress;
    public int         portNumber;
    public Socket      socket;
    public static LPresent    tester;

    
    public LPresent(String address, String port) throws Exception {

	inetAddress = InetAddress.getByName(address);
	portNumber = Integer.parseInt(port);
	socket = new Socket(inetAddress, portNumber);
	input = new BufferedReader
	    (new InputStreamReader(socket.getInputStream()));
	output = new PrintWriter(socket.getOutputStream());

	moreButton = new JButton("more");
	textArea = new JTextArea();
	scrollPane = new JScrollPane(textArea);
	getContentPane().add(scrollPane, "Center");
	getContentPane().add(moreButton, "South");

        moreButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
		readText();
            }
        });
    
	textArea.append("Connected to " + address.toString() + "\n");
	setSize(500,300);

        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
		synchronized(tester) {
		    try {
			socket.close();
		    }
		    catch (Exception ex) {}
		    tester.notifyAll();
		}
            }
        });
    }


    public void readText() {
	String line;

	output.println("GET");
	output.flush();
	try {
	    line = input.readLine();
	}
	catch (Exception e) {
	    System.err.println(e.toString());
            textArea.append("Connection closed\n");
	    return;
	}
	if (line == null) {
	    return;
	}
	textArea.append(line + "\n");
    }


    public static void main(String args[]) throws Exception {
	if (args.length != 3) {
	    System.err.println("usage: LPresent <id> <host> <port>");
	    return;
	}

	tester = new LPresent(args[1], args[2]);
	tester.show();

	synchronized(tester) {
	    tester.wait();
	}
	return;
    }
}
