/*
 *  Present.java  $Revision: 1.1.1.1 $
 *
 *  $Id: Present.java,v 1.1.1.1 1999/12/20 13:11:59 razi Exp $
 *  $Date: 1999/12/20 13:11:59 $
 *
 *  Copyright (C) 1999  Christian Moench
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Christian Moench
 *  Dept. of Computer Science
 *  Johann Wolfgang Goethe-University
 *  60325 Frankfurt, Germany
 *  Tel.  +49 69 79828358
 *  Fax.  +49 69 79823340
 *
 *  $Log: Present.java,v $
 *  Revision 1.1.1.1  1999/12/20 13:11:59  razi
 *  Lokale Indigo Server auf papageno
 *
 *  Revision 2.2  1999/12/15 16:44:13  cristian
 *  new revision
 *
 *  Revision 1.4  1999/12/15 16:27:26  cristian
 *  shorter file
 *
 *  Revision 1.3  1999/12/15 10:19:54  cristian
 *  new demo document with `d_transport' and `invokeAsync'
 *
 *  Revision 1.2  1999/12/13 21:12:38  cristian
 *  started exit handling
 *
 *  Revision 1.1  1999/12/13 18:28:03  cristian
 *  first nettext version
 *
 *
 */
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class Present {

    static BufferedReader input;
    static PrintWriter    output;


    public static void serve() {
	String line;
	BufferedReader fileInput;

	try {
	    fileInput = new BufferedReader
		(new FileReader(Self.getContentFile()));
	}
	catch (IOException e) {
	    System.err.println(e.toString());
	    output.println("Exception: " + e.toString());
	    output.flush();
	    return;
	}

	while (true) {
	    try {
		line = input.readLine();
	    }
	    catch (IOException e) {
		return;
	    }
	    if (line != null) {
		try {
		    line = fileInput.readLine();
		}
		catch (Exception e) {
		    output.println("Exception: " + e.toString());
		    output.flush();
		    return;
		}
		if (line == null) {
		    output.println("------ EOF ------");
		    output.flush();
		    return;
		}
		output.println(line);
		output.flush();
	    }
	    else {
		return;
	    }
	}
    }


    // Present takes two additional arguments, a hostname and a port number
    public static void main(String args[]) {

	if (args.length != 3) {
	    System.err.println("usage: Present <id> <host> <port>");
	    return;
	}

	int number;
	try {
	    number = new Integer(args[2]).intValue();
	}
	catch (Exception e) {
	    System.err.println("Bad port number: " + args[2]);
	    return;
	}

	// Create serving socket and get the port number
	ServerSocket server;
	String[] lpresentargs = new String[2];
	try {
	    server = new ServerSocket(0);
	    lpresentargs[0] = InetAddress.getLocalHost().getHostName();
	    lpresentargs[1] = Integer.toString(server.getLocalPort());
	}
	catch (Exception e) {
	    System.err.println(e.toString());
	    return;
	}

	// Perform document provided transport on myself
	String newId = Base.d_transport(args[1], number, args[0]);

	// Start LPresent method on new document instance
	Base.invokeAsync(args[1], number, newId, "LPresent", lpresentargs);

	try {
	    Socket client;
	    client = server.accept();
	    input = new BufferedReader
		(new InputStreamReader(client.getInputStream()));
	    output = new PrintWriter(client.getOutputStream());
	    serve();
	    client.close();
	    server.close();
	}
	catch (Exception e) {
	    System.err.println(e.toString());
	}
    }
}


