/*
 *  LPresent.java
 *
 */
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;
import javax.swing.*;
import java.security.KeyStore;
import javax.net.*;
import javax.net.ssl.*;
import javax.security.cert.X509Certificate;


public class LPresent extends JFrame{

    JTextArea      textArea;
    JScrollPane    scrollPane;
    JButton        moreButton;
    BufferedReader input;
    PrintWriter    output;

    public InetAddress inetAddress;
    public int         portNumber;
    public SSLSocket      socket;  
    public static LPresent    tester;

    
    public LPresent(String address, String port) throws Exception {

	inetAddress = InetAddress.getByName(address); 
	portNumber = Integer.parseInt(port);
	
	NetSSL netSSL = new NetSSL(address, portNumber);
	socket = netSSL.getSSLSocket();
	socket.startHandshake(); // vielleicht rauswerfen!

	input = new BufferedReader
	    (new InputStreamReader(socket.getInputStream())); 
	output = new PrintWriter(socket.getOutputStream());  

	moreButton = new JButton("more");
	textArea = new JTextArea();
	scrollPane = new JScrollPane(textArea);
	getContentPane().add(scrollPane, "Center");
	getContentPane().add(moreButton, "South");

        moreButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
		readText();
            }
        });
    
	textArea.append("Connected to " + address.toString() + "\n"); 
	setSize(500,300);

        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
		synchronized(tester) {
		    try {
			socket.close(); 
		    }
		    catch (Exception ex) {}
		    tester.notifyAll();
		}
            }
        });
    }


    public void readText() {
	String line;

	output.println("GET");
	output.flush();
	try {
	    line = input.readLine();
	}
	catch (Exception e) {
	    System.err.println(e.toString());
            textArea.append("Connection closed\n");
	    return;
	}
	if (line == null) {
	    return;
	}
	textArea.append(line + "\n");
    }


    public static void main(String args[]) throws Exception {
	if (args.length != 3) {
	    System.err.println("usage: LPresent <id> <host> <port>");
	    return;
	}

	tester = new LPresent(args[1], args[2]);
	tester.show();

	synchronized(tester) {
	    tester.wait();
	}
	return;
    }
}
