/*
 *  Present.java
 *
 */
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.security.KeyStore;
import javax.net.*;
import javax.net.ssl.*;
import javax.security.cert.X509Certificate;


public class Present {

    static BufferedReader input;
    static PrintWriter    output;


    public static void serve() {
	String line;
	BufferedReader fileInput;

	try {
	    fileInput = new BufferedReader
		(new FileReader(Self.getContentFile()));
	}
	catch (IOException e) {
	    System.err.println(e.toString());
	    output.println("Exception: " + e.toString());
	    output.flush();
	    return;
	}

	while (true) {
	    try {
		line = input.readLine();
	    }
	    catch (IOException e) {
		return;
	    }
	    if (line != null) {
		try {
		    line = fileInput.readLine();
		}
		catch (Exception e) {
		    output.println("Exception: " + e.toString());
		    output.flush();
		    return;
		}
		if (line == null) {
		    output.println("------ EOF ------");
		    output.flush();
		    return;
		}
		output.println(line);
		output.flush();
	    }
	    else {
		return;
	    }
	}
    }


    // Present takes two additional arguments, a hostname and a port number
    public static void main(String args[]) {

	if (args.length != 3) {
	    System.err.println("usage: Present <id> <host> <port>");
	    return;
	}

	int number;
	try {
	    number = new Integer(args[2]).intValue();
	}
	catch (Exception e) {
	    System.err.println("Bad port number: " + args[2]);
	    return;
	}

	// Create serving socket and get the port number
	NetSSL netSSL;
	SSLServerSocket server; 
	String[] lpresentargs = new String[2];
	try {
	    netSSL = new NetSSL(0);
	    server = netSSL.getSSLServerSocket(); 
	    // server.setNeedClientAuth(false);
	    lpresentargs[0] = InetAddress.getLocalHost().getHostName(); 
	    lpresentargs[1] = Integer.toString(server.getLocalPort()); 
	}
	catch (Exception e) {
	    System.err.println(e.toString());
	    return;
	}

	// Perform document provided transport on myself
	String newId = Base.d_transport(args[1], number, args[0]);

	// Start LPresent method on new document instance
	Base.invokeAsync(args[1], number, newId, "LPresent", lpresentargs);

	try {
	    SSLSocket client;
	    client = (SSLSocket)server.accept(); 
	    input = new BufferedReader
		(new InputStreamReader(client.getInputStream()));
	    output = new PrintWriter(client.getOutputStream());
	    serve(); 
	    client.close();
	    server.close();
	}
	catch (Exception e) {
	    System.err.println(e.toString());
	}
    }
}
