/*
 *  Copyright (C) 1999  Razi Lotfi-Tabrizi 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Razi Lotfi-Tabrizi
 *  Dept. of Computer Science
 *  Johann Wolfgang Goethe-University
 *  60325 Frankfurt, Germany
 *
 *
 *
 */
import java.lang.*;

public class SDTransport {

    public static void main(String args[]) {

	Io.init();
	Io.println("Hier wird die SDTransport.class gestartet...");
	Io.println("{");
	Io.println("args.length: " + args.length);
	Io.println("Die Argumente der Main-Methode sind:");
	for (int i = 0; i < args.length ; i++) {
	    Io.println("Argument " + i + ":  " + args[i]);
	}
	if (args.length > 0) {
	    Io.println(args[args.length - 1]);
	}
	Io.println("}");
	Io.println("");

	/******************************************************/
	String[] as = {"G", "o"};
	String[] result;
	if (args.length == 1) {
	    result = Base.invoke("localhost", 7333, args[0], "Go", as);
	} else {
	    result = Base.invoke("localhost", 7333, args[0], args[1], as);
	}
	/******************************************************/
	
	Io.println("");
	if (result == null) {
	    Io.println("Error: " + Base.getLastError());
	    return;
	}
	Io.println("result.length1:  " + result.length);
	for (int i = 0; i < result.length; i++) {
	    Io.println("result[" + i + "] := " + result[i]);
	}
	Io.println("");

	/******************************************************/
	Io.println("Starte Base.s_transport:  Dieses Dokument wird nach localhost:7334 geschick und Go gestartet !");
	result = Base.s_transport("localhost", 7334, args[0], "Go", as);
	if (result == null) {
	    Io.println("Error: " + Base.getLastError());
	    return;
	}

	Io.println("result.length2:  " + result.length);
	for (int i = 0; i < result.length; i++) {
	    Io.println("result[" + i + "] := " + result[i]);
	}
	Io.println("");

	/******************************************************/
	try {
	    Thread.currentThread().sleep(10000);
	}
	catch (InterruptedException e) {}
	/******************************************************/
	Io.println("Starte Base.d_transport:  Dieses Dokument wird nach localhost:7334 geschick und Go gestartet !");
	result = Base.d_transport("localhost", 7334, args[0], "Go", as);
	if (result == null) {
	    Io.println("Error: " + Base.getLastError());
	    return;
	}

	Io.println("result.length2:  " + result.length);
	for (int i = 0; i < result.length; i++) {
	    Io.println("result[" + i + "] := " + result[i]);
	}
	Io.println("");

	/******************************************************/
	Io.println("Hier wird die SDTransport.class beendet...");
	try {
	    Thread.currentThread().sleep(60000);
	}
	catch (InterruptedException e) {}
	Io.exit();
    }
}

