import java.io.*;



public class showriff {

    public static void showChunk(String indent,
				 RIFFInputStream in) throws IOException {
	int i, len, offset;
	byte[] line;

	System.out.println(indent
			   + "(Chunk: " + in.currentItem.itemForm
			   + ", size: " + in.currentItem.itemSize);
	line = new byte[8];
	offset = 0;

	// Read a line from the chunk
	len = in.read(line);
	while (len > 0) {
	    int output;

	    System.out.print(indent + "    ");
	    if (offset < 10000) System.out.print("0");
	    if (offset < 1000) System.out.print("0");
	    if (offset < 100) System.out.print("0");
	    if (offset < 10) System.out.print("0");
	    System.out.print(Integer.toString(offset) + ": ");

	    for (i = 0; i < len; i++) {
		if (line[i] < 0) {
		   output = 256 + line[i];
		} else {
		    output = line[i];
		}
		if (output < 16) System.out.print("0");
		System.out.print(Integer.toHexString(output)+ " ");
		offset++;
	    }
	    for (;i < 8; i++) {
		System.out.print("   ");
	    }

	    System.out.print("   ");
	    for (i = 0; i < len; i++) {
		if (line[i] < 32) {
		   System.out.print(".");
		} else {
		    System.out.print((char)line[i]);
		}
	    }
	    System.out.println();

	    // Read a line from the chunk
	    len = in.read(line);
	}
	System.out.println(indent + ")");
    }


    public static void showList(String indent,
				RIFFInputStream in) throws IOException {

	while (in.hasMoreItems()) {
	    in.readItemHeader();
	    if (in.currentItem.isList) {
		System.out.println(indent
				   + "(List: " + in.currentItem.itemForm
				   + ", size: " + in.currentItem.itemSize);
		in.enterList();
		showList(indent + "    ", in);
		in.exitList();
		System.out.println(indent + ")");
	    } else {
		showChunk(indent, in);
	    }
	}
    }


    public static void main(String[] args) throws IOException {
	RIFFInputStream riffInput;

	riffInput = new RIFFInputStream(new FileInputStream(args[0]));
	if (riffInput.currentItem.isList) {
	    System.out.println("(List: " + riffInput.currentItem.itemForm
			       + ", size: " + riffInput.currentItem.itemSize);
	    riffInput.enterList();
	    showList("    ", riffInput);
	    riffInput.exitList();
	    System.out.println(")");
	} else {
	    showChunk("", riffInput);
	}
    }
}
