/**
 * Present.java
 *
 *
 * @author Razi Lotfi-Tabrizi
 * @version
 */

import java.util.*;
import java.io.*;
import java.lang.*;
import java.net.*;



public class Present extends Thread {
    //    private static String      thisDocumentId;
    
    protected int              ThreadTyp;
    protected FileInputStream  fis;
    private File               contentFile;
    private InputStream        inInfo;
    private OutputStream       outInfo;
    private InputStream        inData;
    private OutputStream       outData;
    private ServerSocket       server;
    private Socket             dataSocket;
    private boolean            endOfFileSem;

    private Vector             dataHandleInWorkVec;
    private Vector             breakSemVec;
    private Vector             newInstructionSemVec;
    private Vector             newInstructionVec;    
    private Vector             infoSocketVec;
    //    private Vector             dataSocketVec;
    

    // Der Konstruktor fuer den Info-Thread
    public Present(Vector breakSemVec, Vector newInstructionSemVec, Vector newInstructionVec, 
		   Vector infoSocketVec, Vector dataHandleInWorkVec) {
	this.ThreadTyp = 1;
	this.dataHandleInWorkVec = dataHandleInWorkVec;
	this.breakSemVec = breakSemVec;
	this.newInstructionSemVec = newInstructionSemVec;
	this.newInstructionVec = newInstructionVec;
	this.infoSocketVec = infoSocketVec;
    }

    // Der Konstruktor fuer den Data-Thread
    public Present(File contentFile, Vector breakSemVec, Vector newInstructionSemVec,
		   Vector newInstructionVec, ServerSocket server, Vector dataHandleInWorkVec) {
	this.ThreadTyp = 2;
	this.contentFile = contentFile;
	this.dataHandleInWorkVec = dataHandleInWorkVec;
	this.breakSemVec = breakSemVec; 
	this.newInstructionSemVec = newInstructionSemVec;
	this.newInstructionVec = newInstructionVec;
	this.server = server;
    }

    public void run() {
	System.err.println("Thread Nr. " + ThreadTyp + " is running!");
	switch(ThreadTyp) {
	case 1:
	    infoHandle();
	    break;
	case 2:
	    dataHandle();
	    break;
	default:
	    break;
	}
    }

    public void infoHandle() {
	try {
	    inInfo  = ((Socket)infoSocketVec.elementAt(0)).getInputStream();
	    outInfo = ((Socket)infoSocketVec.elementAt(0)).getOutputStream();
	}
	catch (Exception e) {
	    System.err.println(e.toString());
	}
	
	byte b[] = new byte[100];
	String line = "";
	int len;
	int temp_i = 0;
	
	while (((Integer)newInstructionVec.elementAt(0)).intValue() != 4) {
	    try {
		len = inInfo.read(b);
		line = new String(b, 0, len);
	    }
	    catch (Exception e)	{
		System.err.println(e.toString());
		break;
	    }
	    
	    synchronized(newInstructionSemVec) {
		try {
		    if (line.compareTo("neuladen") == 0) {
			newInstructionVec.setElementAt(new Integer(1),0);
			newInstructionSemVec.setElementAt(new Boolean(true),0);
		    }    
		    else if (line.compareTo("anhalten") == 0) {
			newInstructionVec.setElementAt(new Integer(2),0);
			newInstructionSemVec.setElementAt(new Boolean(true),0);
		    }
		    else if (line.compareTo("weiterladen") == 0) {
			newInstructionVec.setElementAt(new Integer(3),0);
			newInstructionSemVec.setElementAt(new Boolean(true),0);
		    }
		    else if (line.compareTo("ende") == 0) {
			newInstructionVec.setElementAt(new Integer(4),0);
			newInstructionSemVec.setElementAt(new Boolean(true),0);
		    }
		    else {
			System.err.println("error:  Unknown command!");
			newInstructionVec.setElementAt(new Integer(0),0);
			newInstructionSemVec.setElementAt(new Boolean(false),0);
		    }
		    
		    // Hier wartet man eingentlich auf ein notify() des dataHandle(), 
		    // falls er bei der Arbeit ist!!!
		    if (((Boolean)dataHandleInWorkVec.elementAt(0)).booleanValue()) {
			newInstructionSemVec.wait();
		    }
		    
		    System.err.println("Auf der Client-Seite wurde <" + line + "> aufgerufen!");
		    
		    line = "200 Ok";
		    outInfo.write(line.getBytes());
		    outInfo.flush();
		} 
		catch (Exception e) {
		    System.err.println(e.toString());
		}
	    }
	}
	
	do {
	    try {
		Thread.sleep(300);
	    }
	    catch (InterruptedException e){}
	} while (((Boolean)newInstructionSemVec.elementAt(0)).booleanValue()) ;
	
	synchronized(breakSemVec) {
	    
	    breakSemVec.setElementAt(new Boolean(true),0);
	    breakSemVec.notify();
	}
    }
    
    public void dataHandle() {
	int len;
	byte b[] = new byte[100];
	String line="";
	int inst=0;


	try{
	    fis = new FileInputStream(contentFile);
	}
	catch (Exception e) {
	    System.err.println(e.toString());
	}

	while (true) {

	    dataHandleInWorkVec.setElementAt(new Boolean(false),0); 

	    try {
		dataSocket = server.accept();
	    }
	    catch (Exception e) {
		System.err.println(e.toString());
	    }

	    dataHandleInWorkVec.setElementAt(new Boolean(true),0); 

	    try {
		outData = dataSocket.getOutputStream();
	    }
	    catch (Exception e) {
		System.err.println(e.toString());
	    }
	    
	    try {
		while(! ((Boolean)newInstructionSemVec.elementAt(0)).booleanValue()) {	
		    try {
			Thread.currentThread().sleep(300);
		    }
		    catch (InterruptedException e) {}
		}
		
		//    		synchronized(newInstructionSemVec) {
		inst = ((Integer)newInstructionVec.elementAt(0)).intValue();
		newInstructionSemVec.setElementAt(new Boolean(false),0);
		//    		}
	    
		// Falls "ende"
		if (inst == 4) {  
		    try{
			outData.close();
		    }
		    catch (Exception e){
			System.err.println(e.toString());
		    }
		    break;
		}
		// Falls "weiterladen"
		else if (inst == 3){
		    
		}
		// Falls "neuladen"
		else if (inst == 1) {
		    //Hier muss der Zeiger auf den Anfang der Datei zeigen!
		    try{
			fis = new FileInputStream(contentFile);
		    }
		    catch (Exception e) {
			System.err.println(e.toString());
		    }
		}
		
	    
		do {
		    if((len = fis.read(b)) == -1) {
			outData.flush();
			//outData.close();
			System.err.println("Datei zu Ende gelesen!");
			break;
		    }
		    else {
			//System.err.write(b, 0, len);
			outData.write(b,0,len);
			outData.flush();
		    }
		} while(! ((Boolean)newInstructionSemVec.elementAt(0)).booleanValue());
		
		dataHandleInWorkVec.setElementAt(new Boolean(false),0); 

		try{
		    outData.close();
		}
		catch (Exception e){
		    System.err.println(e.toString());
		}
		synchronized(newInstructionSemVec) {
		    newInstructionSemVec.notify();
		}

	    } 
	    catch (Exception e) {
		System.err.println(e.toString());
	    }
	}
	try {
	    fis.close();
	} 
	catch (Exception e) {
	    System.err.println(e.toString());
	}
	
	
    }
    
    

    public static void main(String args[]) {
	Io.init();
	// thisDocumentId = Self.getId();

	Vector breakSemVec = new Vector();
	breakSemVec.addElement(new Boolean(false));

	Vector newInstructionSemVec = new Vector();
	newInstructionSemVec.addElement(new Boolean(false)); 

	Vector dataHandleInWorkVec = new Vector();
	dataHandleInWorkVec.addElement(new Boolean(false));

	Vector newInstructionVec = new Vector();    
	newInstructionVec.addElement(new Integer(0)); 				

	Vector infoSocketVec = new Vector();
	Vector dataSocketVec = new Vector();

	
	if (args.length != 3) 
	    {
		System.err.println("usage: Present <id> <host> <port>");
		return;
	    }
	
	int portnumber;
	try 
	    {
		portnumber = new Integer(args[2]).intValue();
	    }
	catch (Exception e) 
	    {
		System.err.println("Bad port number: " + args[2]);
		return;
	    }
	
	// Einfache Infos ueber die Argumente:
	Io.println("Hier wird die Present.class gestartet...");
	Io.println("{");
	Io.println("args.length: " + args.length);
	Io.println("Die Argumente der Main-Methode sind:");
	for (int i = 0; i < args.length ; i++) 
	    {
		Io.println("Argument " + i + ":  " + args[i]);
	    }
	Io.println("}");
	Io.println("");
	
	// Serving socket erzeugen
	// args[0] ist die DocumentId.
	ServerSocket server;
	String[] lpresentArgs = new String[3];
	try {
	    server = new ServerSocket(0);
	    lpresentArgs[0] = InetAddress.getLocalHost().getHostName();
	    lpresentArgs[1] = Integer.toString(server.getLocalPort());
	    lpresentArgs[2] = args[0];
	}
	catch (Exception e) {
	    System.err.println(e.toString());
	    return;
	}
	Io.println("Starte Present:  Dieses Dokument wird nach " + args[1] + ":" + 
		   args[2] + "\ngeschick und dort wird anschliessend TextView gestartet !\n");   
	
	// Als newId erhaelt man die DocId auf der client-Seite.
	String newId = Base.d_transport(args[1], portnumber, args[0]);
	
	// Starte anschliessend auf dem Client die Methode TextView
	Base.invokeAsync(args[1], portnumber, newId, "TextView", lpresentArgs);
	
	try {		
	    Socket infoSocket = server.accept();
	    infoSocketVec.addElement(infoSocket);
	    Present it = new Present(breakSemVec, newInstructionSemVec, newInstructionVec, 
				     infoSocketVec, dataHandleInWorkVec);
	    it.start();
	
	    File contentFile = Self.getContentFile();
	    Present dt = new Present(contentFile, breakSemVec, newInstructionSemVec, 
				     newInstructionVec, server, dataHandleInWorkVec);
	    dt.start();
	    
	    // Warten bis der Client auf Ende drueckt!
	    synchronized(breakSemVec) {
		try {
		    breakSemVec.wait();
		}
		catch (InterruptedException e){}
	    }
	    try {
		infoSocket.close();
	    } catch (Exception e){}
	    
	    try {
		server.close();
	    } catch (Exception e){}
	}
	catch (Exception e) {
	    System.err.println(e.toString());
	}	
	
	Io.println("Hier wird die Present.class beendet...");
	try {
	    Thread.currentThread().sleep(3000);
	}
	catch (InterruptedException e) {}
	Io.exit();
    }
}
