/**
 *
 * @author
 * @version
 */

import java.lang.*;
import java.io.*;
import java.util.*;
import java.net.*;



public class TextView extends java.awt.Dialog implements Runnable {
    private java.awt.Label label1;
    private java.awt.TextArea textArea1;
    private java.awt.Panel panel1;
    private java.awt.Label label8;
    private java.awt.Label label9;
    private java.awt.Panel panel7;
    private java.awt.Button button1;
    private java.awt.Button button2;
    private java.awt.Button button3;
    private java.awt.Button button4;
    private java.awt.Button button5;
    private java.awt.Button button6;

    protected int          inst = 0;
    protected Vector       breakSemVec;
    public InetAddress     inetAddress;
    public int             portNumber;
    protected Socket       infoSocket; 
    protected Socket       dataSocket;
    protected InputStream  inInfo;
    protected OutputStream outInfo;
    protected InputStream  inData;
    protected OutputStream outData;
    protected int          textAreaPosition = 0;


    /** Initializes the Form */
    public TextView(java.awt.Frame parent, boolean modal, 
		    String address, String port, Vector breakSemVec) {
	super (parent, modal);
	initComponents ();
	
	this.breakSemVec = breakSemVec;
	
	try {
	    inetAddress = InetAddress.getByName(address);
	}
	catch (Exception e) {
	    System.err.println(e.toString());
	}
	    
	try {
	    this.portNumber = Integer.parseInt(port);
	}
	catch (Exception e) {
	    System.err.println(e.toString());
	}

	
	try {
	    infoSocket = new Socket(inetAddress, portNumber);
	    inInfo  = (this.infoSocket).getInputStream();
	    outInfo = (this.infoSocket).getOutputStream();
	} 
	catch (Exception e) {
	    System.err.println(e.toString());
	}
	
	this.setTitle(Self.getId());
	pack ();
    }


    /** This method is called from within the init() method to initialize the form. */
    private void initComponents () {
	addWindowListener (new java.awt.event.WindowAdapter () {
		public void windowClosing (java.awt.event.WindowEvent evt) {
		    closeDialog (evt);
		}
	    });
	
	setLayout (new java.awt.BorderLayout ());

	label1 = new java.awt.Label ();
	label1.setText ("Hier knnen Sie sich den Inhalt des Textes anschauen!");
	label1.setForeground (java.awt.Color.blue);
	label1.setBackground (java.awt.Color.yellow);
	label1.setFont (new java.awt.Font ("Dialog", 1, 12));
	add (label1, "North");

	textArea1 = new java.awt.TextArea ();
	add (textArea1, "Center");
	textArea1.setBackground(java.awt.Color.white);
	textArea1.setEditable(false);

	panel1 = new java.awt.Panel ();
	panel1.setLayout (new java.awt.BorderLayout ());

	label8 = new java.awt.Label ();
	panel1.add (label8, "West");

	label9 = new java.awt.Label ();
	panel1.add (label9, "East");

	panel7 = new java.awt.Panel ();
	panel7.setLayout (new java.awt.GridLayout (1, 6, 15, 15));

	// Neu laden
        button1 = new java.awt.Button ();
        button1.setLabel ("Show");
        button1.addMouseListener (new java.awt.event.MouseAdapter () {
            public void mouseClicked (java.awt.event.MouseEvent evt) {
		nLadenMouseClicked (evt);
            }
	}
				  );
        panel7.add (button1);

	// Anhalten
	button2 = new java.awt.Button ();
        button2.setLabel ("Stop");
        button2.addMouseListener (new java.awt.event.MouseAdapter () {
            public void mouseClicked (java.awt.event.MouseEvent evt) {
		anhaltenMouseClicked (evt);
            }
	}
				  );
        panel7.add (button2);

	// Weiter laden
        button3 = new java.awt.Button ();
        button3.setLabel ("Continue");
        button3.addMouseListener (new java.awt.event.MouseAdapter () {
            public void mouseClicked (java.awt.event.MouseEvent evt) {
		weiterLadenMouseClicked (evt);
            }
	}
				  );
        panel7.add (button3);

	// TextView loeschen
        button5 = new java.awt.Button ();
        button5.setLabel ("Clear");
        button5.addMouseListener (new java.awt.event.MouseAdapter () {
            public void mouseClicked (java.awt.event.MouseEvent evt) {
		clearMouseClicked (evt);
            }
	}
				  );
        panel7.add (button5);

	// Informationen ueber das Dokument ausgeben!
        button6 = new java.awt.Button ();
        button6.setLabel ("Info");
        button6.addMouseListener (new java.awt.event.MouseAdapter () {
            public void mouseClicked (java.awt.event.MouseEvent evt) {
		infoMouseClicked (evt);
            }
	}
				  );
        panel7.add (button6);

	// Ende
        button4 = new java.awt.Button ();
        button4.setLabel ("Quit");
        button4.addMouseListener (new java.awt.event.MouseAdapter () {
            public void mouseClicked (java.awt.event.MouseEvent evt) {
		endeMouseClicked (evt);
            }
	}
				  );
        panel7.add (button4);

	panel1.add (panel7, "Center");

	add (panel1, "South");
    }


    public void getNewDataSocket() {
	try {
	    dataSocket = new Socket(inetAddress, portNumber);
	    inData  = (this.dataSocket).getInputStream();
	    outData = (this.dataSocket).getOutputStream();
	} 
	catch (Exception e) {
	    System.err.println(e.toString());
	}

    }


    //    public synchronized void startTextViewing() {
    public void startTextViewing() {
	Thread th = new Thread(this);
	th.start();
    }

    
    public void run() {
	byte b[] = new byte[100];
	String line = "";
	int len;
	
	synchronized(textArea1) {
	    try {		
		
		// Daten-Verbindung zu dem Server aufbauen!
		getNewDataSocket();
		
		System.err.println("<<<<<<<<<< inst:  " + inst + ">>>>>>>>>>>>>>");
		if (inst == 1) {
		    // Der alte Text wird geloescht. (Geht es auch einfacher?)
		    textArea1.replaceRange("", 0, textAreaPosition);
		    textAreaPosition = 0;
		}
		
		while ((len = inData.read(b)) != -1) { 
		    line = new String(b, 0, len);
		    textArea1.insert(line ,textAreaPosition);
		    textAreaPosition += len;
		    Thread.yield();
		}
		dataSocket.close();
	    }
	    catch (Exception e) {
		System.err.println("Exception error in Thread.run() from " + inst);
		System.err.println(e.toString());
	    }
	}
    }


    private void weiterLadenMouseClicked (java.awt.event.MouseEvent evt) {
	byte b[] = new byte[100];
	int len;
       
	String line = "weiterladen";
	synchronized(outInfo) {
	    try {
		outInfo.write(line.getBytes());
		outInfo.flush();
		
		len = inInfo.read(b); 
		line = new String(b, 0, len);
	    } 
	    catch (Exception e) {
		System.err.println(e.toString());
	    }
	}
	try {		
	    if (line.compareTo("200 Ok") == 0) {
		inst = 3;
		// System.err.println("<<<<<<<<<< inst:  " + inst + ">>>>>>>>>>>>>>");
		startTextViewing();
	    }
	} 
	catch (Exception e) {
	    System.err.println(e.toString());
	}
    }

    private void anhaltenMouseClicked (java.awt.event.MouseEvent evt) {
	byte b[] = new byte[100];
	int len;
	String line = "anhalten";
	synchronized(outInfo) {
	    try {
		outInfo.write(line.getBytes());
		outInfo.flush();
		
		len = inInfo.read(b); 
		line = new String(b, 0, len);
	    } 
	    catch (Exception e) {
		System.err.println(e.toString());
	    }
	}
    }


    private void nLadenMouseClicked (java.awt.event.MouseEvent evt) 
    {
	byte b[] = new byte[100];
	int len;

	String line = "neuladen";
	synchronized(outInfo) {
	    try {
		outInfo.write(line.getBytes());
		outInfo.flush();
			
		len = inInfo.read(b); 
		line = new String(b, 0, len);
	    } 
	    catch (Exception e) {
		System.err.println(e.toString());
	    }
	}

	try {		
	    if (line.compareTo("200 Ok") == 0) {
		inst = 1;
		System.err.println("<<<<<<<<<< inst:  " + inst + ">>>>>>>>>>>>>>");
		startTextViewing();
	    }
	} 
	catch (Exception e) {
	    System.err.println(e.toString());
	}
    }
    
    private void clearMouseClicked(java.awt.event.MouseEvent evt) {
	byte b[] = new byte[100];
	int len;
	String line = "anhalten";
	synchronized(outInfo) {
	    try {
		outInfo.write(line.getBytes());
		outInfo.flush();
		
		len = inInfo.read(b); 
		line = new String(b, 0, len);
	    } 
	    catch (Exception e) {
		System.err.println(e.toString());
	    }
	    
	}
	
	synchronized(textArea1) {
	    // Der alte Text wird geloescht. (Geht es auch einfacher?)
	    textArea1.replaceRange("", 0, textAreaPosition);
	    textAreaPosition = 0;
	}
    }

    
    private void infoMouseClicked(java.awt.event.MouseEvent evt) {
	byte b[] = new byte[100];
	int len;
	String line = "anhalten";
	synchronized(outInfo) {
	    try {
		outInfo.write(line.getBytes());
		outInfo.flush();
		
		len = inInfo.read(b); 
		line = new String(b, 0, len);
	    } 
	    catch (Exception e) {
		System.err.println(e.toString());
	    }
	    
	}
	
	synchronized(textArea1) {
	    // Der alte Text wird geloescht. (Geht es auch einfacher?)
	    textArea1.replaceRange("", 0, textAreaPosition);
	    textAreaPosition = 0;
	    
	    String stringTemp = "Packages: " + Query.packagesToString() + "\n"; 
	    textArea1.insert(stringTemp ,textAreaPosition);
	    textAreaPosition += stringTemp.length();
	    //stringTemp = Self.getId()
	}
    }

    
    private void endeMouseClicked (java.awt.event.MouseEvent evt) {
	byte b[] = new byte[100];
	String line = "ende";
	int len;
	textAreaPosition = 0;

	synchronized(outInfo) {
	    try {
		outInfo.write(line.getBytes());
		outInfo.flush();
			
		len = inInfo.read(b); 
		line = new String(b, 0, len);
	    } 
	    catch (Exception e) {
		System.err.println(e.toString());
	    }
	}
	getNewDataSocket();
	Thread.yield();

	try {
	    infoSocket.close();
	}
	catch (Exception e) {
	    System.err.println(e.toString());
	}
	try {
	    dataSocket.close();
	}
	catch (Exception e) {
	    System.err.println(e.toString());
	}

	dispose();
	synchronized(breakSemVec) {
	    
	    breakSemVec.setElementAt(new Boolean(true),0);
	    breakSemVec.notify();
	}
    }
    

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {
	byte b[] = new byte[100];
	String line = "ende";
	int len;
	textAreaPosition = 0;

	synchronized(outInfo) {
	    try {
		outInfo.write(line.getBytes());
		outInfo.flush();
			
		len = inInfo.read(b); 
		line = new String(b, 0, len);
	    } 
	    catch (Exception e) {
		System.err.println(e.toString());
	    }
	}
	getNewDataSocket();
	Thread.yield();

	try {
	    infoSocket.close();
	}
	catch (Exception e) {
	    System.err.println(e.toString());
	}
	try {
	    dataSocket.close();
	}
	catch (Exception e) {
	    System.err.println(e.toString());
	}

	dispose();
	synchronized(breakSemVec) {
	    
	    breakSemVec.setElementAt(new Boolean(true),0);
	    breakSemVec.notify();
	}
	
	setVisible (false);
//  	dispose ();
    }
    

    public static void main(java.lang.String[] args) throws IOException 
    {
	Vector breakSemVec = new Vector();
	breakSemVec.addElement(new Boolean(false));

	if (args.length != 4) {
	    System.err.println("usage: TextView <id> <host> <port> <remote docid>");
	    return;
	}

	TextView tView = new TextView (new java.awt.Frame (), 
				       false, args[1], args[2], breakSemVec);
	tView.show(); 
	
	synchronized(breakSemVec) {
	    try {
		breakSemVec.wait(); // Wird solange gewartet, bis der Ende-Knopf gedrueckt wird.
	    }
	    catch (InterruptedException e){}
	}
    }
}


