/*
 *  Present.java  $Revision: 1.1 $
 *
 *  $Id: Present.java,v 1.1 1999/12/21 14:52:44 cristian Exp $
 *  $Date: 1999/12/21 14:52:44 $
 *
 *  Copyright (C) 1999  Christian Moench
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Christian Moench
 *  Dept. of Computer Science
 *  Johann Wolfgang Goethe-University
 *  60325 Frankfurt, Germany
 *  Tel.  +49 69 79828358
 *  Fax.  +49 69 79823340
 *
 *  $Log: Present.java,v $
 *  Revision 1.1  1999/12/21 14:52:44  cristian
 *  New document type for scientific work
 *
 *
 */
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class Present {

    // Present takes two additional arguments, a hostname and a port
    // number.
    public static void main(String args[]) {

	int number;
	if (args.length != 3) {
	    System.err.println("usage: Present <id> <host> <port>");
	    return;
	} 
	else {
	    try {
		number = new Integer(args[2]).intValue();
	    }
	    catch (Exception e) {
		System.err.println("Bad port number: " + args[2]);
		return;
	    }
	}

	// Perform server provided transport on self.
	String newId = Base.d_transport(args[1], number, args[0]);

	if (newId == null) {
	    System.out.println("Success: false");
	    System.out.println("    d_transport failed");
	    return;
	}

	// Start CPresent method on remote document instance.
	String[] cargs = new String[1];
	cargs[0] = Pool.deposit("a Value");
	BufferedReader subMethod = new BufferedReader
	    (new InputStreamReader
	     (Base.invokeAsync(args[1], number, newId, "CPresent", cargs)));

	try {
	    System.out.println("Results from CPresent:");
	    String line = subMethod.readLine();
	    while (line != null) {
		System.out.println(line);
		line = subMethod.readLine();
	    }
	    System.out.println();
	} catch (IOException e) {
	    System.out.println("Exception in CPresent: " + e.toString());
	}
	return;
    }
}
