/*
 *  Io.java  $Revision: 2.6 $
 *
 *  $Date: 1999/12/19 16:14:50 $ $Author: razi $
 *
 *  Copyright (C) 1999  Christian Moench
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Christian Moench
 *  Dept. of Computer Science
 *  Johann Wolfgang Goethe-University
 *  60325 Frankfurt, Germany
 *  Tel.  ++49-69-798-28358
 *  Fax.  ++49-69-798-23340
 *
 *  $Log: Io.java,v $
 *  Revision 2.6  1999/12/19 16:14:50  razi
 *  Including IndigoConfig.java
 *
 *  Revision 2.2  1999/12/15 16:39:45  cristian
 *  added deliver with default invokation
 *
 *  Revision 1.2  1999/12/13 18:29:08  cristian
 *  added self-package
 *
 *  Revision 1.1.1.1  1999/07/28 15:55:58  cristian
 *  Initial import
 *
 *  Revision 1.1.1.1  1999/07/22 15:34:06  cristian
 *  Initial release
 *
 *
 */
import java.io.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import javax.swing.*;


public class Io {

    protected static Stack       theTitles = new Stack();
    protected static int         users = 0;
    protected static JFrame      Window;
    protected static JScrollPane Scroller;
    public    static JTextArea   theConsole;

    public static void println(String message) {
	theConsole.append(message + "\n");
    }

    public static void print(String message) {
	theConsole.append(message);
    }

    public static synchronized void init() {
	users = users + 1;
	if (users == 1) {
	    theConsole = new JTextArea();
	    Scroller   = new JScrollPane(theConsole);
	    Window     = new JFrame();
	    Window.setTitle("Indigo console for "
			    + Thread.currentThread().getName());
	    Window.getContentPane().add(Scroller, BorderLayout.CENTER);
	    Window.setSize(500,350);
	    Window.setVisible(true);
	}
	else {
	    theTitles.push(Window.getTitle());
	    Window.setTitle("Indigo console for "
			    + Thread.currentThread().getName());
	}
    }

    public static synchronized void exit() {
	if (users > 0) {
	    users = users - 1;
	    if (users == 0) {
		Window.setVisible(false);
		Window.removeAll();
		Window = null;
	    }
	}
	else {
	    Window.setTitle((String)theTitles.pop());
	}
    }
}
