
/**
 * Net.java
 *
 *
 * Created: Thu Dec  2 18:27:34 1999
 *
 * @author Razi Lotfi-Tabrizi
 * @version
 */

import java.net.*;
import java.lang.*;
import java.io.*;

public class Net 
{
    public    String thisDocumentId;
    public    Socket currentClientSocket;
    public    String indigoPort;
    public    String hostname;
    public    String hostaddress;
    private   MethodThread  mt;

    public    Socket infoSocket;  // Socket fuer den Transport der Informationen und Anweisungen
    public    Socket dataSocket;  // Socket fuer den Datentrasport
    protected int         netPort;     // Die Port-Adresse des Servers
    protected String      netHostname; // Der Hostname des Servers
    protected InetAddress netAddress;  // Die Adresse des Servers
    
    private   ServerSocket  ss;
    private   boolean       IAmServer;
    private   boolean       Mutex1=false; // Solange kein netPort gesetzt wurde ist Mutex1 false

    
    // Ist fuer das ServerSocket erzeugendes Programm (also z.B. Server) gedacht 
    public Net() 
    {
  	mt = (MethodThread)Thread.currentThread();
	thisDocumentId = (String)mt.documentId;
	this.currentClientSocket = (Socket)mt.clientSocket;
	this.indigoPort = IndigoConfig.portToString();
	this.hostname = IndigoConfig.hostnameToString();
	this.hostaddress = IndigoConfig.hostaddressToString();
	
	try 
	    {
		ss = new ServerSocket(0);  // wird ein Socket mit irgendeinem freiem Port erzeugt.
		//ss.setSoTimeout(1000);
		netPort = ss.getLocalPort();
		Mutex1 = true;
		netAddress = ss.getInetAddress();
		netHostname = netAddress.getHostAddress();
		IAmServer = true;
	    }
	catch (IOException e) 
	    {
		System.err.println(e.toString());
	    }
    }
    
    // Dieser Konstruktor ist fuer jenes Programm gedacht, das auf 
    // bestehendes Socket zugreift (also z.B. Client). 
    public Net(String arg_host, int arg_port) 
    {
  	mt = (MethodThread)Thread.currentThread();
	thisDocumentId = (String)mt.documentId;
	this.currentClientSocket = (Socket)mt.clientSocket;
	this.indigoPort = IndigoConfig.portToString();
	this.hostname = IndigoConfig.hostnameToString();
	this.hostaddress = IndigoConfig.hostaddressToString();

	netPort = arg_port;
	Mutex1 = true;
	netHostname = arg_host;
	try 
	    {
		netAddress = InetAddress.getByName(arg_host);
	    }
	catch (UnknownHostException e)
	    {
		System.err.println(e.toString());
	    }
	IAmServer = false;
    }    
    

    /* ACHTUNG: Diese Methode ist auf Server-Seite blockierend!
       (Nur in einem Thread verwenden.) */
    public void initNetSockets() 
    {
	if (IAmServer)
	    {
		try 
		    {
			infoSocket = ss.accept();
			dataSocket = ss.accept();
		    }
		catch (IOException e)
		    {
			System.err.println(e.toString());
		    }
 	    }
	else 
	    {
		try 
		    {
			infoSocket = new Socket(netAddress, netPort);
			dataSocket = new Socket(netAddress, netPort);
		    }
		catch (IOException e)
		    {
			System.err.println(e.toString());
		    }
 	    }
    }

    public int getNetPort()
    {
	while(! Mutex1)
	    {
		try 
		    {
			Thread.currentThread().sleep(300);
		    }
		catch (InterruptedException e) {}
	    }
	return(netPort);
    }
    
    public void setNetport(int arg_port)
    {
	netPort = arg_port;
	Mutex1 = true;
    }
    
    public String getNetHostname()
    {
	return(netHostname);
    }
 
    public InetAddress getNetAddress()
    {
	return(netAddress);
    }
 
    /* ACHTUNG: diese Methode darf erst nach dem Aufruf initNetSockets() benutzt werden! */
    public Socket getInfoSocket()
    {
	return(infoSocket);
    }

    /* ACHTUNG: diese Methode darf erst nach dem Aufruf initNetSockets() benutzt werden! */
    public Socket getDataSocket()
    {
	return(dataSocket);
    }
    
} // Net

