/*
 *  Pool.java  $Revision: 2.1 $
 *
 *  $Date: 1999/12/21 14:53:04 $
 *  $Author: cristian $
 *
 *  Copyright (C) 1999  Christian Moench
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Christian Moench
 *  Dept. of Computer Science
 *  Johann Wolfgang Goethe-University
 *  60325 Frankfurt, Germany
 *  Tel.  ++49-69-798-28358
 *  Fax.  ++49-69-798-23340
 *
 *  $Log: Pool.java,v $
 *  Revision 2.1  1999/12/21 14:53:04  cristian
 *  added pool-package
 *
 *
 */
import java.lang.*;
import java.util.*;


public class Pool {

    private static Hashtable thePool;
    private static long      theKey;

    /*
     * Deposit the object `anObject' at the key `aKey'.
     * key and return the key.
     */
    public static void deposit(String aKey, Object anObject) {
	thePool.put(aKey, anObject);
	return;
    }


    /*
     * Deposit the object `anObject' with a newly created unique
     * key and return the key.
     */
    public static synchronized String deposit(Object anObject) {
	String newKey;

	newKey = Long.toString(theKey);
	theKey = theKey + 1;
	thePool.put(newKey, anObject);
	return newKey;
    }


    /*
     * Read the object at the key `aKey' and return it.
     */
    public static Object read(String aKey) {
	return thePool.get(aKey);
    }


    /*
     * Remove the object at the key `aKey' and return it.
     */
    public static Object remove(String aKey) {
	return thePool.remove(aKey);
    }


    /*
     * Initialize the package
     */
    public static void init() {
	thePool = new Hashtable();
	theKey  = 0;
    }
}
