/*
 *  Self.java 
 * 
 *  $Revision$
 *  $Date$ $Author$
 *
 *  Copyright (C) 1999  Christian Moench
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Christian Moench
 *  Dept. of Computer Science
 *  Johann Wolfgang Goethe-University
 *  60325 Frankfurt, Germany
 *  Tel.  ++49-69-798-28358
 *  Fax.  ++49-69-798-23340
 *
 *  $Log: Self.java,v $
 *  Revision 2.7  1999/12/22 11:03:38  cristian
 *  added group handling
 *
 *  Revision 2.6  1999/12/19 16:14:50  razi
 *  Including IndigoConfig.java
 *
 *  Revision 2.2  1999/12/15 16:39:45  cristian
 *  added deliver with default invokation
 *
 *  Revision 1.1  1999/12/13 18:29:08  cristian
 *  added self-package
 *
 *
 */
import java.io.*;
import java.util.*;
import java.lang.*;
import java.security.cert.*;
import java.security.*;


public class Self {

    public static Hashtable theMethodThreads;

    public static String getId() {
	ThreadGroup tg = (ThreadGroup)Thread.currentThread().getThreadGroup();
	MethodThread mt = (MethodThread)theMethodThreads.get(tg);
	return mt.documentId;
    }

    public static File getContentFile() {
	ThreadGroup tg = (ThreadGroup)Thread.currentThread().getThreadGroup();
	MethodThread mt = (MethodThread)theMethodThreads.get(tg);
	return new File(mt.documentStore.getContentName(mt.documentId));
    }

    public static String getContentFileName() {
	return(getContentFile().getPath());
    }

    public static String getContentFileName(String id) {
	return(getContentFileName());
    }

    public static void init() {
	theMethodThreads = new Hashtable();
    }

    public static void PrintContentFileInfo() {
	File dcf = getContentFile();
	Io.println("Informations about the \"Content\" of the document " + 
		   getId() + ":");
	Io.println("   Name = " + dcf.getName());
	Io.println("   AbsolutePath = " + dcf.getAbsolutePath());
	Io.println("   toString = " + dcf.toString());
	Io.println("   length = " + dcf.length());
	Io.println("   Parent = " + dcf.getParent());
	
	Date lmd = new Date(dcf.lastModified());
	GregorianCalendar cal = new GregorianCalendar();
	cal.setTime(lmd);
	String ret = "";
	int    value = cal.get(Calendar.DAY_OF_WEEK);
	switch (value) {
	    case Calendar.SUNDAY:
		ret += "Sunday";
		break;
	    case Calendar.MONDAY:
		ret += "Monday";
		break;
	    case Calendar.TUESDAY:
		ret += "Tuesday";
		break;
	    case Calendar.WEDNESDAY:
		ret += "Wednesday";
		break;
	    case Calendar.THURSDAY:
		ret += "Thursday";
		break;
	    case Calendar.FRIDAY:
		ret += "Friday";
		break;
	    case Calendar.SATURDAY:
		ret += "Saturday";
		break;
	}
	ret += ", ";
	ret += cal.get(Calendar.DATE) + ".";
	ret += (cal.get(Calendar.MONTH)+1) + ".";
	ret += cal.get(Calendar.YEAR);
	ret += " ";
	ret += cal.get(Calendar.HOUR_OF_DAY);
	ret += ":";
	ret += cal.get(Calendar.MINUTE);
	ret += ":";
	ret += cal.get(Calendar.SECOND);
	Io.println("   lastModified = " + ret);
    }

    public static long ContentFileLength() {
  	File dcf = getContentFile();
	return(dcf.length());
    }
    
    public static String ContentFileParent() {
  	File dcf = getContentFile();
	return(dcf.getParent());
    }

    public static long ContentFileLastModified() {
   	File dcf = getContentFile();
  	return(dcf.lastModified());
    }

    public static String ContentFileLastModifiedToString() {
  	File dcf = getMethodsFile();

	Date lmd = new Date(dcf.lastModified());
	GregorianCalendar cal = new GregorianCalendar();
	cal.setTime(lmd);
	String ret = "";
	int    value = cal.get(Calendar.DAY_OF_WEEK);
	switch (value) {
	    case Calendar.SUNDAY:
		ret += "Sunday";
		break;
	    case Calendar.MONDAY:
		ret += "Monday";
		break;
	    case Calendar.TUESDAY:
		ret += "Tuesday";
		break;
	    case Calendar.WEDNESDAY:
		ret += "Wednesday";
		break;
	    case Calendar.THURSDAY:
		ret += "Thursday";
		break;
	    case Calendar.FRIDAY:
		ret += "Friday";
		break;
	    case Calendar.SATURDAY:
		ret += "Saturday";
		break;
	}
	ret += ", ";
	ret += cal.get(Calendar.DATE) + ".";
	ret += (cal.get(Calendar.MONTH)+1) + ".";
	ret += cal.get(Calendar.YEAR);
	ret += " ";
	ret += cal.get(Calendar.HOUR_OF_DAY);
	ret += ":";
	ret += cal.get(Calendar.MINUTE);
	ret += ":";
	ret += cal.get(Calendar.SECOND);
	return(ret);
    }
    
    public static File getAttributesFile() {
	ThreadGroup tg = (ThreadGroup)Thread.currentThread().getThreadGroup();
	MethodThread mt = (MethodThread)theMethodThreads.get(tg);
	return new File(mt.documentStore.getAttributesName(mt.documentId));
    }

    public static void PrintAttributesFile() {
  	File dcf = getAttributesFile();
	BufferedReader br;
	String line;

	Io.println("The attributes of the document " + getId() + ":");
	
	try {
	    br = new BufferedReader(new FileReader(dcf));
	    while ((line = br.readLine()) != null) {
		Io.print("   ");
		Io.println(line);
	    }
	    br.close();
	} catch (IOException e) {
	    System.err.println("Error by acces:   document method file");
	}	
    }

    public static File getMethodsFile() {
	ThreadGroup tg = (ThreadGroup)Thread.currentThread().getThreadGroup();
	MethodThread mt = (MethodThread)theMethodThreads.get(tg);
	return new File(mt.documentStore.getMethodsName(mt.documentId));
    }

    public static void PrintMethodsFile() {
  	File dcf = getMethodsFile();
	BufferedReader br;
	String line;

	Io.println("The document " + getId() + " supports these document methods:");
	
	try {
	    br = new BufferedReader(new FileReader(dcf));
	    while ((line = br.readLine()) != null) {
		Io.print("   ");
		Io.println(line);  //oder doch println???
		//System.out.println(line);
	    }
	    br.close();
	} catch (IOException e) {
	    System.err.println("Error by acces:   document method file");
	}	
    }

    public static Hashtable getAttributes() throws IOException {
	BufferedReader attributesReader;
	Attributes     theAttributes;
	Hashtable      attributesHashtable;

	theAttributes = new Attributes();
	attributesReader = new BufferedReader(
	    new FileReader(getAttributesFile()));
	theAttributes.readFrom(attributesReader);
	attributesHashtable = theAttributes.theAttributes;
	return(attributesHashtable);
    }

    public static java.security.cert.Certificate getAuthorCertificate() {
	String multiLineBegin =  "<MULTILINE>";
	String multiLineEnd   = "</MULTILINE>";
	String rawCert;
	String authorCertStr = null;
	java.security.cert.Certificate authorCert = null;
	Hashtable authorAttri;
	CertificateFactory cf;
	
	try {
	    authorAttri = getAttributes();
	    rawCert = (String)(authorAttri.get("AuthorCertificate"));
	    if (rawCert == null) {
		throw new IOException("AuthorCertificate is null!");
	    }
	}
	catch (Exception e) {
	    return null;
	}	
	
	try {
	    java.util.regex.Pattern pattern =
		java.util.regex.Pattern.compile("(.+)(-----BEGIN CERTIFICATE-----.+-----END CERTIFICATE-----)(.+)", java.util.regex.Pattern.DOTALL);
	    java.util.regex.Matcher matcher = pattern.matcher(rawCert);
	    if (matcher.matches()) {
  		authorCertStr = matcher.group(2);
	    }
	    
	    if (authorCertStr == null) {
		return null;
	    }
	    
	    cf = CertificateFactory.
		getInstance((String)
			    (authorAttri.get("AuthorCertificateType")));
	    ByteArrayInputStream bais = new ByteArrayInputStream(authorCertStr.getBytes());
	    
  	    while (bais.available() > 0) {
  		authorCert = cf.generateCertificate(bais);
  	    }
 	}
	catch (Exception e) {
//  	    System.err.println(e); 
	    return null;
	}

	return authorCert;
    }
 
    public static java.security.PublicKey getAuthorPublicKey() {
	java.security.cert.Certificate authorCert = getAuthorCertificate();
	if (authorCert == null) {
	    return null;
	}
	else {
	    java.security.PublicKey pKey = authorCert.getPublicKey();
	    return(pKey);
	}
    }

    public static String getContentFileDigitalSignatureToString() {
	String multiLineBegin =  "<MULTILINE>";
	String multiLineEnd   = "</MULTILINE>";
	String rawDigSig;
	String docDigSigStr = null;
	Signature docDigSig = null;
	Hashtable authorAttri;
	
	try {
	    authorAttri = getAttributes();
	    rawDigSig = (String)(authorAttri.get("DocumentContentDigitalSignature"));
	    if (rawDigSig == null) {
		throw new IOException("DocumentContentDigitalSignature is null!");
	    }
	}
	catch (Exception e) {
	    return null;
	}	
	
	try {
	    java.util.regex.Pattern pattern =
		java.util.regex.Pattern.compile("(.+)(-----BEGIN SIGNATURE-----.+-----END SIGNATURE-----)(.+)", java.util.regex.Pattern.DOTALL);
	    java.util.regex.Matcher matcher = pattern.matcher(rawDigSig);
	    if (matcher.matches()) {
  		docDigSigStr = matcher.group(2);
	    }
	    
	    if (docDigSigStr == null) {
		return null;
	    }
 	}
	catch (Exception e) {
	    return null;
	}
	
	return docDigSigStr;
    }

    public static boolean verifyContentFileDigitalSignature() {
	String multiLineBegin =  "<MULTILINE>";
	String multiLineEnd   = "</MULTILINE>";
	String rawDigSig;
	String docDigSigStr = null;
	Signature docDigSig = null;
	Hashtable authorAttri;
	FileInputStream quelle;
	byte[] data = new byte[1024];
	byte[] sig;
	boolean result;

	try {
	    authorAttri = getAttributes();
	    rawDigSig = (String)(authorAttri.get("DocumentContentDigitalSignature"));
	    if (rawDigSig == null) {
		throw new IOException("DocumentContentDigitalSignature is null!");
	    }
	}
	catch (Exception e) {
	    return false;
	}	
	
	try {
	    java.util.regex.Pattern pattern =
		java.util.regex.Pattern.compile("(.+)-----BEGIN SIGNATURE-----\\n(.+)\\n-----END SIGNATURE-----(.+)", java.util.regex.Pattern.DOTALL);
	    java.util.regex.Matcher matcher = pattern.matcher(rawDigSig);
	    if (matcher.matches()) {
  		docDigSigStr = matcher.group(2);
	    }
	    	    
	    if (docDigSigStr == null) {
		return false;
	    }
	    
	    sig =  ((new sun.misc.BASE64Decoder()).decodeBuffer(docDigSigStr));

	    docDigSig = 
		Signature.getInstance((String)(authorAttri.get("DocumentContentDigitalSignatureType")));
	    docDigSig.initVerify(getAuthorPublicKey());
	    
	    quelle = new FileInputStream(getContentFileName());
  	    int iii;
	    while( (iii = quelle.read(data)) != -1 ) {
		docDigSig.update(data, 0, iii);
	    }
	    quelle.close();
	    
	    result = docDigSig.verify(sig); 
	}
	catch (Exception e) {
//  	    System.err.println("ERROR DURING THE VERIFYING OF DOCUMENT SIGNATURE!\n" 
//	    + e.toString());
	    return false;
	}
	return result;
    }

}

