/*
 *  Indigo.java  $Revision: 2.7 $
 *
 *  $Id: Indigo.java,v 2.7 1999/12/21 14:53:33 cristian Exp $
 *  $Date: 1999/12/21 14:53:33 $
 *
 *  Copyright (C) 1999  Christian Moench
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Christian Moench
 *  Dept. of Computer Science
 *  Johann Wolfgang Goethe-University
 *  60325 Frankfurt, Germany
 *  Tel.  +49 69 79828358
 *  Fax.  +49 69 79823340
 *
 *  $Log: Indigo.java,v $
 *  Revision 2.7  1999/12/21 14:53:33  cristian
 *  added multiplexed standard output for document methods
 *
 *  Revision 2.6  1999/12/19 16:14:51  razi
 *  Including IndigoConfig.java
 *
 *  Revision 2.5  1999/12/19 15:59:00  razi
 *  IndigoConfig.java was added.
 *
 *  Revision 2.4  1999/12/15 17:07:37  razi
 *  test
 *
 *  Revision 2.3  1999/12/15 17:01:10  indigo-developer
 *  razis test
 *
 *  Revision 2.2  1999/12/15 16:37:20  cristian
 *  cleanups
 *
 *  Revision 1.3  1999/12/13 18:30:06  cristian
 *  new method scheme started
 *
 *  Revision 1.2  1999/08/05 13:11:27  cristian
 *  private thread for methods, improved security handler,
 *  single start file for applet and application
 *
 *  Revision 1.1  1999/07/30 14:21:48  cristian
 *  removed IndigoApplet.java
 *  Indigo.java now serves as Applet and Application starting point
 *
 *
 */
import java.applet.*;


public class Indigo extends Applet {

    public static boolean           isApplet;
    public static MetaDocumentStore theStore;

    /*
     * Execution starts with this method if we are an application.
     */
    static public void main(String[] args) {

        IndigoConfig.init();
        System.out.println("");
        IndigoConfig.printProperty();
        System.out.println("");

	// Remember that we are no applet.
	isApplet = false;

	// Start serving.
	IndigoServer.startServing(IndigoConfig.documentRootToString());

	return;
    }


    /*
     * Execution starts with this method if we are an applet.
     */
    public void init() {

        IndigoConfig.init();

	// Remember that we are an applet.
	isApplet = true;

	// Start serving.
	IndigoServer.startServing(IndigoConfig.documentRootToString());

	return;
    }    


    public String[][] getParameterInfo() {
	String info[][] =
	        {{"indigo.documentdir", "String", "The document directory"}};
	return info;
    }


    public String getAppletInfo() {
	return new String("Indigo Server Applet\n"
			  + "Version 0.1\n" 
			  + "Copyright (C) 1999 Christian Mnch\n");
    }
}
