
/**
 * IndigoAuthorization.java
 *
 *
 * Created: Sat Feb 23 03:01:07 2002
 *
 * @author Razi Lotfi-Tabrizi
 * @version
 */

import java.io.*;
import java.lang.*;
import java.util.*;


public class IndigoAuthorization extends IndigoConfig {
    private boolean clientHasValidCert;
    private String  clientAccountBASE64;
    private String  superUserAccountBase64;
    private String  currentAccesscontrolllist;
    private Hashtable methodHashtable;
    private String  currentRunningMode;
    private String  currentUserMode;
    private String  methodName;
    private boolean authorizedForMethod;
    private boolean needWWWAuthenticateResponseHeader;
    
    public IndigoAuthorization(boolean clientHasValidCert, 
			       String clientAccountBASE64) {
	this.clientHasValidCert     = clientHasValidCert;
	this.clientAccountBASE64    = clientAccountBASE64;
	this.superUserAccountBase64 = super.getSuperUserAccountBase64();
	this.currentAccesscontrolllist      = super.getCurrentAccesscontrolllist();
	this.currentRunningMode     = super.getCurrentRunningMode();
	
	this.methodHashtable = new Hashtable();
	
	java.util.regex.Pattern pattern = 
	    java.util.regex.Pattern.
	    compile("\\((.+)\\)\\((.+)\\)\\((.+)\\)");
	java.util.regex.Matcher matcher = 
	    pattern.matcher(super.getCurrentAccesscontrolllist());
	if (matcher.matches()) {
	}

	if (currentRunningMode.equalsIgnoreCase("true")) {
	    // If ClientAuthentication is true
	    if (clientHasValidCert) {
		if ((this.superUserAccountBase64).equals(this.clientAccountBASE64)) {
		    // SUPERUSER
		    currentUserMode = "s";
		    needWWWAuthenticateResponseHeader = false;
		    this.currentAccesscontrolllist = matcher.group(1);
		}
		else {
		    // GROUP
		    currentUserMode = "g";
		    needWWWAuthenticateResponseHeader = true;
		    this.currentAccesscontrolllist = matcher.group(2);
		}
	    }
	    else {
		// OTHER
		currentUserMode = "o";
		needWWWAuthenticateResponseHeader = false;
		this.currentAccesscontrolllist = matcher.group(3);
	    }
	}
	else if (currentRunningMode.equalsIgnoreCase("maybe")) {
	    // If ClientAuthentication is maybe
	    if (clientHasValidCert) {
		if ((this.superUserAccountBase64).equals(this.clientAccountBASE64)) {
		    // SUPERUSER
		    currentUserMode = "s";
		    needWWWAuthenticateResponseHeader = false;
		    this.currentAccesscontrolllist = matcher.group(1);
		}
		else {
		    // GROUP
		    currentUserMode = "g";
		    needWWWAuthenticateResponseHeader = true;
		    this.currentAccesscontrolllist = matcher.group(2);
		}
	    }
	    else {
		// OTHER
		currentUserMode = "o";
		needWWWAuthenticateResponseHeader = false;
		this.currentAccesscontrolllist = matcher.group(3);
	    }
	}
	else {
	    // If ClientAuthentication is false
	    // ACHTUNG: In diesem Fall sind GROUP und OTHERS gleich!
	    if ((this.superUserAccountBase64).equals(this.clientAccountBASE64)) {
		// SUPERUSER
		currentUserMode = "s";
		needWWWAuthenticateResponseHeader = false;
		this.currentAccesscontrolllist = matcher.group(1);
	    }
	    else {
		// OTHER
		currentUserMode = "o";
		needWWWAuthenticateResponseHeader = true;
		this.currentAccesscontrolllist = matcher.group(3);
	    }
	}

	String[] stringArray = (this.currentAccesscontrolllist).split(",");
	for (int i = 0; i < stringArray.length; i++) {
	    this.methodHashtable.put(stringArray[i].toLowerCase(),
				     stringArray[i].toLowerCase());
	}

  	IndigoOut.errPrintln("   >> This user is " + currentUserMode);
	IndigoOut.errPrintln("   >> He can execute this methods: " + this.currentAccesscontrolllist);

    }


    public boolean authorizedFor(String operation) {
	if (methodHashtable.containsKey("all")) {
	    return(true);
	}
	else if (methodHashtable.containsKey("none")) {
	    return(false);
	}
	else {
	    return(methodHashtable.containsKey(operation.toLowerCase()));
	}
    }

    public boolean needWWWAuthenticateResponseHeader() {
	return(this.needWWWAuthenticateResponseHeader);
    }
    
} // IndigoAuthorization










