
/**
 * IndigoSSLServerSocket.java
 *
 *
 * Created: Mon Feb 11 21:09:27 2002
 *
 * @author Razi Lotfi-Tabrizi
 * @version
 */

import java.io.*;
import java.net.*;
import java.security.KeyStore;
import javax.net.*;
import javax.net.ssl.*;
import javax.security.cert.X509Certificate;
import java.lang.*;
import java.util.*;


public class IndigoSSLServerSocket {
    private SSLServerSocketFactory ssf;
    private ServerSocket theServer;
    private IndigoSSLContext indigoSSLContext;

    public IndigoSSLServerSocket() {
	if (IndigoConfig.secureExtension()) {
	    indigoSSLContext = new IndigoSSLContext();
	    ssf = null;
	    try {
		ssf = (indigoSSLContext.getSSLContext()).getServerSocketFactory();
	    } 
	    catch (Exception e) {
		e.printStackTrace();
	    }	
	}
	else {
	    indigoSSLContext = null;
	    ssf = null;
	}
    }

    public ServerSocket createServerSocket() {
	if (IndigoConfig.secureExtension()) {
	    try {
		theServer = (SSLServerSocket)ssf.createServerSocket();
	    } 
	    catch (Exception e) {
		e.printStackTrace();
	    }	
	    // Ob eine Client-Authentifizierung ntig ist (true, maybe, false)!
	    IndigoConfig.clientAuth((SSLServerSocket)theServer);
	    
	    return((SSLServerSocket)theServer);
	} 
	else {
	    try {
		theServer = new ServerSocket();
	    } 
	    catch (Exception e) {
		e.printStackTrace();
	    }	

	    return(theServer);
	}
    }
    
    public ServerSocket createServerSocket(int portNumber) {
	if (IndigoConfig.secureExtension()) {
	    try {
		theServer = (SSLServerSocket)ssf.createServerSocket(portNumber);
	    } 
	    catch (Exception e) {
		e.printStackTrace();
	    }	
	    // Ob eine Client-Authentifizierung ntig ist (true, maybe, false)!
	    IndigoConfig.clientAuth((SSLServerSocket)theServer);
	    
	    return((SSLServerSocket)theServer);
	} 
	else {
	    try {
		theServer = new ServerSocket(portNumber);
	    } 
	    catch (Exception e) {
		e.printStackTrace();
	    }	

	    return(theServer);
	}
    }
    
    public static ServerSocket getServerSocket(int port) {
	IndigoSSLServerSocket iss = new IndigoSSLServerSocket();
	ServerSocket serverSocket = iss.createServerSocket(port);
	return(serverSocket);
    }
    
    public static ServerSocket getServerSocket() {
	IndigoSSLServerSocket iss = new IndigoSSLServerSocket();
	ServerSocket serverSocket = iss.createServerSocket();
	return(serverSocket);
    }

    public SSLServerSocketFactory getSSLServerSocketFactory() {
	return(ssf);
    }
    
    public IndigoSSLContext getIndigoSSLContext() {
        return(indigoSSLContext);
    }

} // IndigoSSLServerSocket
