
/**
 * IndigoSSLSocket.java
 *
 *
 * Created: Mon Feb 11 22:05:01 2002
 *
 * @author Razi Lotfi-Tabrizi
 * @version
 */

import java.io.*;
import java.net.*;
import java.security.KeyStore;
import javax.net.*;
import javax.net.ssl.*;
import javax.security.cert.X509Certificate;
import java.lang.*;
import java.util.*;


public class IndigoSSLSocket {
    private SSLSocketFactory ssf;
    private Socket sslSocket;
    private IndigoSSLContext indigoSSLContext;

    public IndigoSSLSocket() {
	if (IndigoConfig.secureExtension()) {
	    indigoSSLContext = new IndigoSSLContext();
	    ssf = null;
	    try {
		ssf = (indigoSSLContext.getSSLContext()).getSocketFactory();
	    } 
	    catch (Exception e) {
		e.printStackTrace();
	    }	
	}
	else {
	    indigoSSLContext = null;
	    ssf = null;
	}
    }

    public Socket createSocket(String host, int port) {
	if (IndigoConfig.secureExtension()) {
	    try {
		sslSocket = (SSLSocket)ssf.createSocket(host, port);
	    } 
	    catch (Exception e) {
		e.printStackTrace();
	    }	
	    return((SSLSocket)sslSocket);
	}
	else {
	    try {
		sslSocket = new Socket(host, port);
	    } 
	    catch (Exception e) {
		e.printStackTrace();
	    }	
	    return((Socket)sslSocket);
	}
    }

    public Socket createSocket(InetAddress host, int port) {
        return(this.createSocket(host.getHostName(), port));
    }

    public static Socket getSocket(String host, int port) {
	IndigoSSLSocket iss = new IndigoSSLSocket();
	Socket sslSocketInit = iss.createSocket(host, port);
	return(sslSocketInit);
    }

    public SSLSocketFactory getSSLSocketFactory() {
	return(ssf);
    }

    public IndigoSSLContext getIndigoSSLContext() {
        return(indigoSSLContext);
    }

} // IndigoSSLSocket


