import java.lang.*;
import java.util.*;


class LocalURL {


    public String   theSearch;
    public String[] theSearchParts;

    public String   thePath;
    public String[] thePathParts;


    public LocalURL(String aPath) throws Exception {
	int searchPartIndex;

	searchPartIndex = aPath.indexOf('?');
	if (searchPartIndex == -1) {
	    theSearch = null;
	    thePath = aPath;
	    theSearchParts = new String[0];
	} else {
	    theSearch = aPath.substring(searchPartIndex + 1);
	    thePath = aPath.substring(0, searchPartIndex);

	    if (theSearch.length() == 0) {
		throw new Exception("empty search part");
	    }

	    StringTokenizer searchSplitter;
	    searchSplitter = new StringTokenizer(theSearch, "&");
	    theSearchParts = new String[searchSplitter.countTokens()];
	    for (int i = 0; i < theSearchParts.length; i++) {
		try {
		    theSearchParts[i] = searchSplitter.nextToken();
		}
		catch (Exception e) {
		    System.err.println("LocalPath#LocalPath: " + e.toString());
		    return;
		}
	    }
	}

	if (thePath.length() == 0) {
	    throw new Exception("empty local part");
	}

	StringTokenizer partSplitter;
	partSplitter = new StringTokenizer(thePath, "/");
	thePathParts = new String[partSplitter.countTokens()];
	for (int i = 0; i < thePathParts.length; i++) {
	    try {
		thePathParts[i] = partSplitter.nextToken();
	    }
	    catch (Exception e) {
		System.err.println("LocalPath#LocalPath: " + e.toString());
		return;
	    }
	}
    }
}
