import java.io.*;
import java.util.*;
import java.lang.*;

public class Utility {

    public static String[] split(String toSplit) {
	int             tokens;
	String[]        result;
	StringTokenizer splitter;

	splitter = new StringTokenizer(toSplit);
	tokens   = splitter.countTokens();

	result = new String[tokens];	
	for (int i = 0; i < tokens; i++) {
	    try {
		result[i] = splitter.nextToken();
	    }
	    catch (Exception e) {
		return null;
	    }
	}
	return result;
    }


    public static Hashtable readHeader(BufferedReader input)
	    throws IOException {
	int       index;
	String    line, name, value;
	Hashtable header;

	header = new Hashtable();
	while (true) {
	    line = input.readLine();
	    line.trim();
	    if (line.length() == 0) {
		return header;
	    }
	    index = line.indexOf(':');
	    if (index == -1) {
		throw new IOException("Bad header line: " + line);
	    }
	    name  = line.substring(0, index);
	    value = line.substring(index + 1);
	    name.trim();
	    value.trim();
	    header.put(name.toLowerCase(), value);
	}
    }
}





